:
#!/bin/sh

# undshar.sh (bundled with dshar Ver.2.10)	by nide@ics.nara-wu.ac.jp
#	Shell script on UNIX to extract dshar'ed files

#### Configuration part
FROMMSK_def="nkf -e"
 # Default command to convert KANJI from MS-KANJI code
 # Note that nkf can't handle 1byte kana characters!
#### End of config

# main
Overwrite=0
Notexec=0
Textmode=0
ConvMSK=0
ConvMSK_need=0
FromMSK_use="${DSHAR_FROMMSK-${FROMSJIS-$FROMMSK_def}}"
# Old sh doesn't know ':-' substitution
TrimCR="tr -d '\015\032'"
LC_CTYPE=C; export LC_CTYPE # to make locale void

sh -c '
	TMP_TouchTest=/tmp/.tchtst$$
	trap '\''E=$?; rm -rf $TMP_TouchTest; exit $E'\'' 0 1 2 3 15
	umask 077
	mkdir $TMP_TouchTest && cd $TMP_TouchTest || exit 7
		  touch -t 9001010000.00 a && [ -f a ] && [ ! -f *0 ] && exit 2
	/usr/5bin/touch -t 9001010000.01 b && [ -f b ] && [ ! -f *1 ] && exit 5
		  touch 0101000090.02 c && [ -f c ] && [ ! -f *2 ] && exit 1
	/usr/5bin/touch 0101000090.03 d && [ -f d ] && [ ! -f *3 ] && exit 4
		  touch 0101000094 e && [ -f e ] && [ ! -f *4 ] && exit 0
	/usr/5bin/touch 0101000095 f && [ -f f ] && [ ! -f *5 ] && exit 3
	exit 6
' 2>/dev/null; Touch=$?

while :; do
	case "$1" in
	 # Options must be specified separately
	-c)	Overwrite=1; shift;;
	-n)	Notexec=1; shift;;
	-t)	Textmode=1; shift;;
	-k)	ConvMSK=1; shift;;
	-v)	FromMSK_use="$2"; ConvMSK_need=1; shift 2;;
	-v*)	FromMSK_use="`expr X\"$1\" : '...\\(.*\\)'`";
		ConvMSK_need=1; shift;;
	--)	shift; break;;
	-)	break;;
	-*)
		echo Illegal option: "$1" 1>&2
		exit 1;;
	*)
		break;;
	esac
done
if [ $ConvMSK_need$ConvMSK = 10 ]; then
	echo 'Warning: -v option is meaningless unless -k is specified.' 1>&2
fi

cat ${1+"$@"} | tr -d '\015\032' | awk '# old awk will do
	BEGIN{
		overwrite = 0'$Overwrite'
		textmode = 0'$Textmode'
		convmsk = 0'$ConvMSK'
		frommsk = "'"$FromMSK_use"'"
		trimcr = "'"$TrimCR"'"
		eofmark = "~EOF"
		tmpdir = "'/usr/tmp/"${LOGNAME-${USER-dshartmp}}"X$$'"
		tmpname = tmpdir "'/_dtmp.$$'"
		for(i = 0; i <= 16; i++)
			ctoi[substr("0123456789ABCDEF", i + 1, 1)] = i
		for(i = 0; i <= 6; i++)
			ctoi[substr("abcdef", i + 1, 1)] = i + 10
		# stoi["other string"] is 0
		print ":\n#!/bin/sh\nLC_CTYPE=C; export LC_CTYPE\nCURSIZE=-1"
		if(textmode || convmsk){
			printf "trap \"rm -rf %s; exit 1\" 1 2 3 15\n", \
						tmpdir
			printf "rm -rf %s\nmkdir %s && chmod 700 %s\n", \
						tmpdir, tmpdir, tmpdir
		}
		if(convmsk){
			printf "echo \"(\"Kanji conversion command: "
			printf "'\''%s'\''\")\"\n", frommsk
		}

		if(0'$Touch' == 7){
			print "echo '\''touch test failure; " \
						"time-stamps not restored'\''"
		} else if(0'$Touch' == 6){
			print "echo '\''warning: time-stamps not restored'\''"
		}
	}
	NR == 1, /^: This is a command.com archive/{
		next
	}

	okflg == 0{
		if($0 ~ /^:\*[0-9]*$/){
			oknext = substr($0, 3)
			if(oknext ~ /^$/){
				okflg = -1; next
			}
			if(oknext != 1){
				notseq = 1; exit		
			} else okflg = 1
			next
		}
		if($0 !~ /^(:|[\t ]*$)/){
			cannot = 1; exit
		}
	}

	/^:\|~$/, /^:\|$/{
		if($0 ~ /^:\*[0-9]*$/){
			oknext = substr($0, 3)
			if(oknext ~ /^$/ || oknext != okflg + 1){
				notseq = 1; exit
			} else okflg++
		}
		next
	}

	/^:end~of~arch/{
		endflg = 1; next
	}
	/^:[\t ]*\(You (can|may) put (any )?addi/, 1 == 0{
		if(igextflg == 0){
			for(; iflevel > 0; iflevel--) print "fi"
			igextflg = 1
			next
		}
		if($0 !~ /^(:|[\t ]*$|echo [^|<>]*$)/){
			if(igextflg == 1){
				printf "echo \"(Ignored following "
				print "extra command(s) near EOF...)\""
				igextflg = 2
			}
			if($0 ~ /'\''/){
				qline = ""
				for(i = 1; i <= length($0); i++){
					c = substr($0, i, 1)
					if(c ~ /^'\''$/) c = "'\''\\'\'\''"
					qline = qline c
				}
			} else qline = $0
			printf "echo '\''%s'\''\n", qline
		}
		next
	}

	/^echo extracting/{
		if(catlevel) print eofmark; catlevel = 0
		for(; iflevel > 0; iflevel--) print "fi"
		if($3 ~ /^[A-Za-z]:/){
			drvdir = substr($3, 1, 2)
			 # should I fold 'B:' to 'b:' ?
			if(drvexist[drvdir] == 0){
				drvexist[drvdir] = 1
				printf "[ -d '\''%s'\'' ] ||\n", drvdir
				printf "\tmkdir '\''%s'\'' && ", drvdir
				printf "chmod u+rwx '\''%s'\''\n", drvdir
			}
			filename = drvdir "/" substr($3, 3)
		} else filename = $3
		if(filename ~ /^[^\.\/]/ ){
			usefilename = "./" filename
		} else {
			usefilename = filename
		}
		if(overwrite == 0){
			printf "if [ -f '\''%s'\'' -o ", usefilename
			printf "-d '\''%s'\'' ]; then\n", usefilename
			printf "\techo File already exists: "
			printf "skipping '\''%s'\''\n", filename
			printf "else\n"
			iflevel++
		}
		printf "echo extracting %s\n", filename
		next
	}
	/^if NOT EXIST/ && $5 == "%2"{
		dir = substr(filename, 1, length($6))
		if(filename != usefilename) dir = "./" dir
		printf "[ -d '\''%s'\'' ] ||\n", dir
		printf "\tmkdir '\''%s'\'' && ", dir
		printf "chmod u+rwx '\''%s'\''\n", dir
		next
	}
	/^:\|$/{
		if(decodeflg == 0){
			decodeflg = 1
			extfile = filename
			if(textmode || convmsk) extfile = tmpname

			i = split(extfile, extpath, "/")
			# on old awk, 3rd arg of split must be a string?
			if(i <= 1){
				printf "uudecode << '\''%s'\''\n", eofmark
				printf "begin 644 %s\n", extfile
			} else {
				extbase = extpath[i]
				extdir = substr(extfile, 1, \
					length(extfile) - 1 - length(extbase))
				if(extbase == "") extbase = "."
				if(extdir == "") extdir = "/"
				if(extdir !~ /^\//) extdir = "./" extdir

				printf "(cd '\''%s'\'' && uudecode)", extdir
				printf " << '\''%s'\''\n", eofmark
				printf "begin 644 %s\n", extbase
			}
			split("", extpath)	# erase extpath

			catlevel++
		} else {
			decodeflg = 0
			printf "`\nend\n%s\n", eofmark; catlevel = 0
			printf "CURSIZE=\"`wc -c < '\''%s'\'' | awk ", extfile
			printf "'\''{printf \\\"%%x\\\", $1}'\''`\"\n"
			if(textmode || convmsk){
				if(textmode){ # includes text&&conv
					printf "%s", trimcr
				} else {
					printf "%s", frommsk
				}
				printf " < '\''%s'\''", tmpname
				if(convmsk && textmode){
					printf " | %s", frommsk
				}
				printf " > '\''%s'\'' &&\n", usefilename
				printf "\trm '\''%s'\'' ||\n\techo ", tmpname
				if(convmsk){
					printf "converting from MS-KANJI code"
				} else {			
					printf "trailing '\''CR & ^Z'\''"
				}
				printf " of '\''%s'\'' failed\n", filename
			}
			printf "chmod u+r '\''%s'\'' 2>/dev/null\n", \
								usefilename
			printf "[ -f '\''%s'\'' ] ||\n", usefilename
			printf "\techo failed extracting '\''%s'\''\n", \
			  filename
		}
		next
	}
	/^ if NOT EXIST/ && $5 == "%0" || \
	/^ if EXIST/ && $4 == "goto" {
		printf "[ -d '\''%s'\'' ] ||\n", usefilename
		printf "\techo failed extracting '\''%s'\''\n", filename
		next		
	}
	decodeflg != 0{
		if($0 !~ /^:/){
			cannot = 1; exit
		}
		printf "%c%s\n", 32 + int((length($0) - 1) * 3 / 4), \
		  substr($0, 2)
		next
	}

	# misc controls
	!/^if NOT ERR/ || $5 != "%2"{
		next
	}
	$6 ~ /:[0-9A-Za-z]*[13579BDFbdf]\//{
		printf "chmod a-w '\''%s'\'' ||\n", usefilename
		printf "\techo restore attribute of '\''%s'\'' failed\n", \
		  filename
		next
	}
	$6 ~ /:[0-9A-Za-z]+\.$/{
		datestr = sprintf("%10s", $6)
		year = (int((ctoi[substr(datestr, 6, 1)] * 16 + \
			     ctoi[substr(datestr, 7, 1)]) / 2) + 1980) % 100
		mon  = (int((ctoi[substr(datestr, 7, 1)] * 16 + \
			     ctoi[substr(datestr, 8, 1)]) / 2)) % 16
		day  = (int((ctoi[substr(datestr, 8, 1)] * 16 + \
			     ctoi[substr(datestr, 9, 1)]))) % 32
		hour = (int((ctoi[substr(datestr, 2, 1)] * 16 + \
			     ctoi[substr(datestr, 3, 1)]) / 8)) % 32
		minu = (int((ctoi[substr(datestr, 3, 1)] * 16 + \
			     ctoi[substr(datestr, 4, 1)]) / 2)) % 64
		seco = (int((ctoi[substr(datestr, 4, 1)] * 32 + \
			     ctoi[substr(datestr, 5, 1)]) * 2)) % 64
		if(0'$Touch' >= 6) printf ": "
		else if(0'$Touch' >= 3) printf "/usr/5bin/"
		if(0'$Touch' % 3 == 0)
		    printf "touch %02d%02d%02d%02d%02d '\''%s'\''", \
			  mon, day, hour, minu, year, usefilename
		else if(0'$Touch' % 3 == 1)
		    printf "touch %02d%02d%02d%02d%02d.%02d '\''%s'\''", \
			  mon, day, hour, minu, year, seco, usefilename
		else
		    printf "touch -t %02d%02d%02d%02d%02d.%02d '\''%s'\''",\
			  year, mon, day, hour, minu, seco, usefilename
		printf " ||\n\techo restore time-stamp of '\''%s'\'' failed\n",\
		  filename
		next
	}
	$6 ~ /:[0-9A-Za-z]+$/{
		printf "if [ \"$CURSIZE\" != \"%s\" ]; then\n\techo ", \
		  substr($6, 2, length($6) - 1)
		printf "'\''%s'\'': file size mismatch on extraction\nfi\n", \
		  filename
	}

	END{
		if(catlevel) print eofmark; catlevel = 0
		for(; iflevel > 0; iflevel--) print "fi"
		if(textmode || convmsk) printf "rm -rf %s\n", tmpdir

		if(notseq){
			if(oknext == 0){
				print "echo Non-multipart archive found\\!"
			} else {
				printf "echo \\! Part %d appears ", oknext
				if(okflg == 0){
					printf "first."
				} else {
					printf "next to part %d.", okflg
				}
				print " Please reorder all parts in sequence."
			}
			print "exit 1"; exit 1
		}
		if(cannot){
			print "echo This archive cannot be unbundled by " \
				"this version of undshar.; exit 1"
			exit 1
		}
		if(okflg == 0){
			print "echo Archive not found '\''!?'\''; exit 1"
			exit 1
		}
		if(endflg == 0){
			if(okflg < 0){
				print "echo Short archive'\''?!?'\''"
			} else {
				printf "echo Part %d not found. ", ++okflg
				print "Must speficy all parts in sequence."
			}
			print "exit 1"; exit 1
		}
		print "exit 0 # Just in case..."
	}
' | {
	[ "$Notexec" = 1 ] && cat || sh
}
