#ifndef UNIX
#  define USE_STDARG
#  define SIGFN_VOID
#endif

#ifndef TOMSK_def /* for UNIX only */
#  define TOMSK_def "nkf -s"
#endif

#include <stdio.h>
#include <ctype.h>
#include <time.h>
#include <fcntl.h>
#include <signal.h>
#ifdef UNIX
#  include <errno.h> /* MS-DOSłperror()͎gĂȂ */
#  include <sys/types.h>
#  include <sys/stat.h>
#else
#  include <dos.h>
#  include <io.h>
#endif
#ifdef USE_STDARG
#  include <stdarg.h>
#else
#  include <varargs.h>
#endif
#ifndef NOFILE
#  define NOFILE 20
#endif

#ifdef UNIX
 /* UNIXł͌݁Aɑ΂z͓ɂȂ */
#  define iskanjipos(p) 0
#else
 /* iskanjipos() is defined in setargs.c */
#endif

#ifdef LSI_C
#  define is_alpha(c) isalpha(c)
#  define is_space(c) isspace(c)
#  define is_digit(c) isdigit(c)
#  define is_xdigit(c) isxdigit(c)
#  define is_upper(c) isupper(c)
#  define is_lower(c) islower(c)
#  define to_lower(c) tolower(c)
#  define to_upper(c) toupper(c)
#else
#  define is_alpha(c) (isascii(c) && isalpha(c))
#  define is_space(c) (isascii(c) && isspace(c))
#  define is_digit(c) (isascii(c) && isdigit(c))
#  define is_xdigit(c) (isascii(c) && isxdigit(c))
#  define is_upper(c) (isascii(c) && isupper(c))
#  define is_lower(c) (isascii(c) && islower(c))
#  define to_lower(c) (is_upper(c) ? tolower(c) : (c))
#  define to_upper(c) (is_lower(c) ? toupper(c) : (c))
#endif
#define	strconstlen(s) (sizeof(s) - 1)
#define strconsthead(s, h) (!strncmp((s), (h), strconstlen(h)))
#define ctoi(c) ((c) - ((c) <= '9' ? '0' : (c) <= 'Z' ? 'A' - 10 : 'a' - 10))

#ifdef UNIX
#  define isdelim(c) ((c) == '/')
#  define isdrvmk(c) 0
#  define DELIM	"/"
#else
#  define isdelim(c) ((c) == '\\' || (c) == '/')
#  define isdrvmk(c) ((c) == ':')
#  define DELIM	"\\"
#endif
#define isDelim(c) (isdelim(c) || isdrvmk(c))

#define MAXPATHLEN 256

#define dosname(s) nameconv((s), 1)
#define unixname(s) nameconv((s), 0)

extern	char	*malloc(), *calloc(), *realloc();
extern	char	*getenv(), *mktemp(), *strcpy(), *strncpy();
extern	long	atol();
#ifdef UNIX
extern	int	errno;
#endif

#ifdef MSC4
#  define atexit(func) (onexit(func) == NULL)
#endif
#ifndef LSI_C
#  define fsetbin(fp) setmode(fileno(fp), O_BINARY)
#endif

#ifndef SETARGS_MAIN
#  define public extern
#else
#  define SETARGS_DSHAR
#  define public
#endif
public	char	*nameconv(), *emalloc();
public	char	*strsave(), *strcatsave(), *strpathcatsave();
public	void	setargs();
public	FILE	*fopen_chk();
#ifdef UNIX
public	FILE	*piperdopen(), *pipewropen();
#endif
#define execrdopen(cmd, av, silentp) piperdopen((cmd), (av), NULL, silentp)

#ifdef SIGFN_VOID
typedef	void	(*sigfuncp)();
#else
typedef	int	(*sigfuncp)();
#endif

#if defined(MSC4) || defined(__TURBOC__)
struct	find_t {
	char	reserved[21], attrib;
	short	wr_time, wr_date;
	long	size;
	char	name[13]; /* v43bytes */
};
#endif
#define DTASIZE	128

#if !defined(FPRINTF_NOVAL) && !defined(fprintf)
#  define xfprintf fprintf
#endif

#define MULTIMINbyK 5L
