#include "common.h"
#ifdef UNIX
#  define ITOLMASK ((long)(unsigned int)(~0))
#else
#  define ITOLMASK (2L << (8 * sizeof(int) - 1)) - 1)
#endif

static	xfprintlx(), xfprintld();

 /* fprintf()̒ȃTuZbgŁAƏo̓oCgԂ́B
    ݉\ȃtH[}bg %%, %[-][.]#s, %[l]d, %[l]x, %c
     "#"  '0' Ŏn܂Ȃ '*' ł邱ƁB     */
/*VARARGS*/
#ifdef USE_STDARG
int	xfprintf(f, p)
register FILE	*f;
char	*p;
#else /* USE_STDARG */
int	xfprintf(f, p, va_alist)
register FILE	*f;
register char	*p;
va_dcl
#endif /* USE_STDARG */
{
	int	retval = 0, digits, outlen, exdigits, longp, leftp, dotp;
	union	{
		char	*s;
		char	c;
		long	l;
	} tmpval;
	va_list	ap;

#ifdef USE_STDARG
	va_start(ap, p);
#else
	va_start(ap);
#endif
	while(*p){
		if(*p != '%'){
			for(tmpval . s = p; *p && *p != '%'; p++);
			outlen = p - tmpval . s;
			if(outlen != fwrite(tmpval . s, 1, outlen, f))
				goto err;
			retval += outlen;
			continue;
		}

		if(*++p == '%'){
			if(EOF == putc(*p, f)) goto err;
			retval++, p++;
			continue;
		}

		if(0 != (leftp = (*p == '-'))){
			p++;
		}
		if(0 != (dotp = (*p == '.'))){
			p++;
		}
		if(*p == '*'){
			digits = va_arg(ap, int), exdigits = 1;
			p++;
		} else if(is_digit(*p)){
			if(*p == '0') goto insuff;
			for(exdigits = 1, digits = 0; is_digit(*p); p++){
				digits *= 10, digits += *p - '0';
			}
		} else {
			exdigits = 0;
			if(leftp || dotp) goto insuff;
		}
		/* if(exdigits && !digits) goto insuff; */
		if(0 != (longp = (*p == 'l'))) p++;

		switch(*p){
		case 's':
			if(longp) goto insuff;
			tmpval . s = va_arg(ap, char *);
			if(exdigits){
				if(dotp){
					for(outlen = 0; *tmpval.s;
							tmpval.s++, outlen++){
						if(outlen == digits) break;
					}
					tmpval . s -= (digits = outlen);
				} else {
					outlen = strlen(tmpval . s);
				}

				if(leftp){
					if(outlen != fwrite(tmpval . s, 1,
								outlen, f))
						goto err;
					retval += outlen;
				}
				if((digits -= outlen) > 0){
					retval += digits;
					while(--digits) putc(' ', f);
					if(EOF == putc(' ', f)) goto err;
				}
				if(!leftp){
					if(outlen != fwrite(tmpval . s, 1,
								outlen, f))
						goto err;
					retval += outlen;
				}
			} else {
				outlen = strlen(tmpval . s);
				if(outlen != fwrite(tmpval . s, 1,
								outlen, f))
					goto err;
				retval += outlen;
			}

			p++;
			continue;
		case 'c':
			if(longp || leftp || dotp || exdigits) goto insuff;
			tmpval . c = va_arg(ap, int); /* ł̂? */
			if(EOF == putc(tmpval . c, f)) goto err;
			retval++, p++;
			continue;
		case 'd':
		case 'x':
			if(leftp || dotp || exdigits) goto insuff;
			if(longp){
				tmpval . l = va_arg(ap, long);
			} else {
				tmpval . l = (long)va_arg(ap, int);
			}
			if(*p == 'd'){
				outlen = xfprintld(f, tmpval . l);
			} else {
				if(!longp) tmpval . l &= ITOLMASK;
				outlen = xfprintlx(f, tmpval . l);
			}
			if(-1 == outlen) goto err;
			retval += outlen;
			p++;
			continue;
		default:
		insuff:
			xfprintf(stderr, "Bug: insufficient xfprintf()\n");
			exit(1);
		}
	}
	if(ferror(f)) goto err;
	va_end(ap);
	return retval;
err:
	va_end(ap);
	return -1;
}

static	xfprintlx(f, l)
register FILE	*f;
long	l;
{
	register int	c;
	long	lsft;
	int	retval = 0;

	lsft = (l >> 4) & ((1L << (8 * sizeof(long) - 4)) - 1L);
	if(lsft != 0L) retval = xfprintlx(f, lsft);
	c = (int)(l & 0x0f);
	return(EOF == putc(c + (c < 10 ? '0' : 'a' - 10), f) || ferror(f) ?
		-1 : (retval + 1));
}

static	xfprintld(f, l)
register FILE	*f;
long	l;
{
	register int	retval = 0;
	int	minusp = 0, minusmaxp = 0;

	if(l < 0L){
		putc('-', f), minusp = 1;
		if(l == -l)(l--, minusmaxp = 1); else l = -l;
	}

	if(l / 10L != 0L) retval = xfprintld(f, l / 10L);
	return(EOF == putc((int)(l % 10L) + '0' + minusmaxp, f) || ferror(f) ?
		-1 : (minusp + retval + 1));
}
