#include "common.h"

#ifndef UNIX
static	char	**tmpfnames = NULL;
static	int	tmpfcnt = 0;
#endif

char	ver[] = "2.10";

#ifdef UNIX
static	char	strusage[] = "\
dshar Ver %s\n\
Usage: dshar [-o outfile] [-m size[b]] [-e extra_cmd] [-E extra_cmd_file]\n\
	     [-v filter] [-btk] [-q {0|1|2}] [-p level] [-d add_path]\n\
	     FILE FILE... > ARCHIVE.bat\n\
";
#else
static	char	strusage[] = "\
dshar Ver %s\n\
Usage: dshar [-o outfile] [-m size[b]] [-e extra_cmd] [-E extra_cmd_file]\n\
	     [-q {0|1|2}] [-p level] [-d add_path] FILE FILE... > ARCHIVE.bat\n\
";
#endif

#ifdef UNIX
#  define Time time
#else
long	Time(tp)
long	*tp;
{
	long	t;

	do{
		time(&t); time(tp);
	} while(3600UL < (unsigned long)(*tp - t));
}
#endif

imax(a, b)
register int	a, b; /* ̏ꍇl̂ */
{
	return a > b ? a : b;
}

void	usage()
{
	fprintf(stderr, strusage, ver);
	exit(1);
}

void	diskfull()
{
	fprintf(stderr, "write failed (maybe disk full?)\n");
	exit(1);
}

long	atoxl(s) /* ͍lĂȂ */
register char	*s;
{
	long	retval = 0;

	while(is_xdigit(*s)) (retval <<= 4, retval += (long)ctoi(*s), s++);
	return retval;
}

#ifndef UNIX
void	flskbf()
{
	union	REGS	in, out;

	in . x . ax = 0xc00;
	intdos(&in, &out);
}
#endif

char	*strtime()
{
	register char	*ts;
#if defined(UNIX) && !defined(HAVE_NO_TIME_T)
	time_t	t;
#else
	long	t;
#endif

	Time(&t);
	(ts = ctime(&t))[24] = '\0';
	return ts;
}

#ifdef UNIX
FILE	*tmpdfile() /* tmpfile()̑p tmpfile()͈ꕔ̎łunsecure
  mkstemp()͏glibcł̓t@C0666ō̂ŎgȂ */
{
	static	char	base[] = "/tmp/.tmp";
	char	name[sizeof(base) + 8 + 2];
	unsigned long	i = ((long)getpid() * 0x8001) ^ (long)time(NULL);
	FILE	*f;
	int	terrno;

	strcpy(name, base);
	for(;; i++){
	  	sprintf(name + sizeof(base)-1, "%08lx",
	  		i & (long)0xffffffffL);
		if(mkdir(name, 0700) == 0) break;
		if(errno != EEXIST) return NULL;
	}
	chmod(name, 0700); /* just in case... */
	strcpy(name + sizeof(base)-1 + 8, "/a");
	f = fopen(name, "w+b");
	terrno = errno;
	unlink(name);
	*(name + sizeof(base)-1 + 8) = '\0';
	rmdir(name);
	errno = terrno;
	return f;
}

FILE	*temporalfile() /* NULL͕ԂȂ */
{
	register FILE	*retf;

	if(NULL == (retf = tmpdfile())){
		fprintf(stderr, "Can't create tempfile\n"), exit(1);
	}
	return retf;
}
#else /* MS-DOS */
FILE	*temporalfile() /* NULL͕ԂȂ */
 /* MSC4tmpfile()͂ "\\tmp" gƂ(?)̂ŖɗȂ
    LSI_Ctmpfile()̓JgfBNgɈꎞt@C낤Ƃ̂
    JgfBNg݋֎~̏ꍇlƎgȂ */
{
	register FILE	*retf;
	register char	*base;
	union	REGS	in, out;
	struct	SREGS	segreg;
	sigfuncp orghand;

	if(NULL == (base = getenv("TMP")) &&
	   NULL == (base = getenv("TEMP"))) base = "";
	if(NULL == (base = strpathcatsave(base, ".\\XXXXXXXX.XXX.")))
		(fprintf(stderr, "Can't make temporal file name\n"), exit(1));
	base[strlen(base) - 14] = '\0';

	orghand = signal(SIGINT, SIG_IGN);

	in . h . ah = 0x5a;
	in . x . cx = 2;
	in . x . dx = FP_OFF(base);
	segreg . ds = FP_SEG((char far *)base);
	intdosx(&in, &out, &segreg);
	if(out . x . cflag) err_cantopen(base);

#if 0
	_dos_close(out . x . ax);
#else
	in . x . bx = out . x . ax;
	in . h . ah = 0x3e;
	intdos(&in, &out);
#endif /* to avoid LSI-C3.30c bug */

	if(NULL == (retf = fopen(base, "w+"))) err_cantopen(base);
	tmpfnames = (char **)emalloc(
			(char *)tmpfnames, sizeof(char *) * ++tmpfcnt);
	tmpfnames[tmpfcnt - 1] = base;
	signal(SIGINT, orghand);
	fsetbin(retf);
	return retf;
}

void	exit_hndl()
{
	register int	i;

	signal(SIGINT, SIG_IGN);
	fcloseall();
	for(i = tmpfcnt; i--; ) unlink(tmpfnames[i]);
}

void	intr_exit()
{
	signal(SIGINT, SIG_IGN);
	fprintf(stderr, "\033[m");
	exit(1);
}
#endif

#ifdef UNIX
addenv(s)
char	*s;
{
	extern	char	**environ;
	register char	**pp, *p, *q, **qq;
	char	**oldenv;
	static	char	**newenv = NULL;

	for(pp = environ; *pp != NULL; pp++){
		for(p = *pp, q = s; *p == *q && *p; p++, q++){
			if(*p == '=') return (*pp = s), 0;
		}
	}
	oldenv = newenv;
	if(NULL == (newenv = (char **)calloc(
					(pp - environ) + 2, sizeof(char *))))
		return -1; /* realloc()ɂׂ? */
	for(pp = environ, qq = newenv; *pp != NULL; pp++, qq++) *qq = *pp;
	*qq++ = s, *qq = NULL, environ = newenv;
	if(oldenv != NULL) free(oldenv);
	return 0;
}
#endif

#ifdef UNIX
/* ------------------------- using stat() ------------------------- */
filemode(name)
register char	*name;
{
	struct	stat	statbuf;

	if(0 != stat(name, &statbuf)) (perror(name), exit(1));
	return (statbuf . st_mode & S_IWRITE) ? 0x20 : 0x21;
}

long	filesize(name)
register char	*name;
{
	struct	stat	statbuf;

	if(0 != stat(name, &statbuf)) (perror(name), exit(1));
	return statbuf . st_size;
}

long	filedate(name)
register char	*name;
{
	struct	stat	statbuf;
	register struct	tm	*tmbuf;

	if(0 != stat(name, &statbuf)) (perror(name), exit(1));
	tmbuf = localtime(&statbuf . st_mtime);
	if(tmbuf -> tm_year < 80) return 0x21L;
	if(tmbuf -> tm_year > 80 + 99) return 0xbf7dc79fL;
	return ((long)(tmbuf -> tm_year - 80) << 9) |
	       ((long)(tmbuf -> tm_mon + 1) << 5) |
	       ((long)(tmbuf -> tm_mday)) |
	       ((long)(tmbuf -> tm_hour) << 27) |
	       ((long)(tmbuf -> tm_min) << 21) |
	       ((long)(tmbuf -> tm_sec / 2) << 16);
}
#else /* UNIX */
/* ------------------------- using DOS func ------------------------- */
filemode(name)
register char	*name; /* dosname()ŌĂł */
{
	int	mode;

	if(0 != _dos_getfileattr(dosname(name), &mode)){
		fprintf(stderr, "%s: Can't get attribute\n", unixname(name));
		exit(1);
	}
	return mode;
}

long	filesize(name) /* dosname()ŌĂł */
register char	*name; /* wildcard܂܂ʂ */
{
	struct	find_t	tmpdta;

	if(0 != _dos_findfirst_e5(dosname(name), 0x27, &tmpdta)){
		fprintf(stderr, "%s: Not found\n", unixname(name));
		exit(1);
	}
	return tmpdta . size;
}

long	filedate(name)
register char	*name; /* dosname()ŌĂł */
{
	int	fd;
	unsigned int	status, fdate, ftime;

	if(0 != _dos_open(dosname(name), O_RDONLY, &fd)) err_cantopen(name);
	status = _dos_getftime(fd, &fdate, &ftime);
	_dos_close(fd);
	if(status){
		fprintf(stderr, "%s: Can't get time-stamp\n",
			unixname(name)), exit(1);
	}
	return ((long)ftime << 16) | ((long)fdate & 0xffffL);
}
#endif /* MSDOS vs. UNIX */
/* ------------------------- End of DOS funcs ------------------------- */

#ifdef UNIX
FILE	*txtwropen(orgf) /* CR+LF -> LF */
register FILE	*orgf;
{
	static	char	*av[] = {
		"tr", "-d", "\\015", NULL
	};

	return pipewropen(*av, av, orgf, 0);
	 /* Ƃwait()邱 */
}

FILE	*txtrdopen(orgf) /* LF -> CR+LF ^Z͎菜 */
register FILE	*orgf;
{
	static	char	*av[] = {
		"sed", "/^\032$/d\n/\r$/!s/$/\r/", NULL
		 /* Rg[XNvgɓĂĂsed
		    garbledȂƎv̂c */
	};

	return piperdopen(*av, av, orgf, 0);
	 /* Ƃwait()邱 */
}

FILE	*mskrdopen(orgf, tomsk_cmd)
register FILE	*orgf; /* orgfcloseAVI[vFILEԂ */
register char	*tomsk_cmd;
{
	static	char	*av[] = {
		"sh", "-c", NULL, NULL
	};

	av[2] = tomsk_cmd;
	return piperdopen(*av, av, orgf, 0);
	 /* Ƃwait()邱 */
}
#endif /* UNIX */
