#define SETARGS_MAIN
#ifdef DEBUGALONE
#  define DEBUG
#endif
#include "common.h"

#define RESPF	'@'
#define STRSTDIN "<stdin>"
#ifndef  BRAEXCEPT
#  define BRAEXCEPT  '^'
#endif

static	void	addarg(), addindarg(), addindfarg(), addf1arg(), add1arg();
#ifndef UNIX
static	void	addfarg(), adddirarg();
static	char	*strdircatsave();
static	int	can_cd_there();
#else
static	void	addfoundarg();
#endif
#ifdef SETARGS_DSHAR /* @@g */
static	void	addindaarg(), addindafarg();
#endif
static	void	do_qsortarg();

static	int	newac, newavsize;
static	char	**newav;

static	struct	sortrange {
	unsigned int	begin, end;
} *mustsort = NULL;
static	int	mustsort_num = 0;

#ifndef UNIX
static	unsigned int	conv_e5(r, f)
unsigned int	r;
char	*f;
{
	if(!r && *(f = ((struct find_t *)f) -> name) == 5) *f = 0xe5;
	return r;
}

unsigned int	_dos_findfirst_e5(p, r, f)
char	*p;
unsigned int	r;
struct	find_t	*f;
{
	return conv_e5(_dos_findfirst(p, r, f), (char *)f);
}

unsigned int	_dos_findnext_e5(f)
struct	find_t	*f;
{
#if 0
	char	*p;

	if(0xe5 == *(p = f -> name)) *p = 5;
#endif
	return conv_e5(_dos_findnext(f), (char *)f);
}
#endif

void	err_cantopen(s)
register char	*s;
{
#ifndef UNIX
	fprintf(stderr, "%s: Can't open\n", unixname(s)), exit(1);
#else
	perror(s), exit(1);
#endif
}

FILE	*fopen_chk(fnm, mode)
register char	*fnm, *mode;
{
	register FILE	*retf;

	if(NULL == (retf = fopen(fnm, mode))) err_cantopen(fnm);
	return retf;
}

#ifdef UNIX
isdir(name)
register char	*name;
{
	struct	stat	statbuf;

	return(0 == stat(name, &statbuf) &&
	       S_IFDIR == (statbuf . st_mode & S_IFMT));
}
#else
isdir(name)
register char	*name;
{
	register char	*tmp;
	struct	find_t	tmpt;

	tmp = strpathcatsave(name, ".");
	name = dosname(tmp);
	free(tmp);
	return 0 == _dos_findfirst_e5(name, 0x37, &tmpt) ?
			tmpt . attrib & 0x10 : can_cd_there(name);
}

static	int	can_cd_there(s)
register char	*s;
{
	void	(*orig_int)();
	char	dirbuf[MAXPATHLEN + 1], *curdir, curdrv, newdrv;
	int	retval;
	union	REGS	in, out;
	struct	SREGS	segreg;

	in . h . ah = 0x19;
	curdrv = (char)intdos(&in, &out);

	if(
#ifndef LSI_C
	   isascii(*s) &&
#endif
	   isalpha(*s) && isdrvmk(s[1])){
#ifndef LSI_C
		newdrv = *s - (islower(*s) ? 'a' : 'A'), s += 2;
#else
		newdrv = tolower(*s) - 'a', s += 2;
#endif
	} else {
		newdrv = curdrv;
	}

	orig_int = signal(SIGINT, SIG_IGN);
	in . h . ah = 0xe;
	in . h . dl = newdrv;
	intdos(&in, &out);

	in . h . ah = 0x19;
	if(0 != (retval = ((char)intdos(&in, &out) == newdrv))){
		curdir = dirbuf + 1;
		in . h . ah = 0x47;
		in . h . dl = 0;
		segreg . ds = FP_SEG((char far *)curdir);
		in . x . si = FP_OFF(curdir);
		intdosx(&in, &out, &segreg);
		if(out . x . cflag){ /* s͂Ȃ͂ */
			retval = 0;
		} else {
			if(*curdir != '\\') *--curdir = '\\';

			in . h . ah = 0x3b;
			segreg . ds = FP_SEG((char far *)s);
			in . x . dx = FP_OFF(s);
			intdosx(&in, &out, &segreg);
			retval = !out . x . cflag;
			in . h . ah = 0x3b;
			segreg . ds = FP_SEG((char far *)curdir);
			in . x . dx = FP_OFF(curdir);
			intdosx(&in, &out, &segreg); /* sȂ͂ */
		}
	}
	
	in . h . ah = 0xe;
	in . h . dl = curdrv;
	intdos(&in, &out);

	signal(SIGINT, orig_int);
	return retval;
}
#endif

char	*emalloc(p, i) /* NULL͕ԂȂ */
register char	*p;
register unsigned int	i;
{
	if(NULL == (p = (char *)(p == NULL ? malloc(i) : realloc(p, i)))){
		fprintf(stderr, "Memory exhausted\n"), exit(1);
	}
	return p;
}

#ifdef UNIX
static	wfork()
{
	register int	retval, i;

	if(-1 != (retval = fork())) return retval;
	fprintf(stderr, "Process table full, fork() waiting...\n");
	for(i = 0; i < 5; i++){
		sleep(2);
		if(-1 != (retval = fork())) return retval;
	}
	return -1;
}

static	void	closenonstd()
{
	register int	i;

	for(i = 3; i < NOFILE; i++) close(i);
}
#endif

static	fgetword(f, s, l)
FILE	*f;
char	*s;
int	l;
{
	register int	c;
	register char	*p;

	if(feof(f)) return EOF;
	while(c = getc(f), is_space(c));
	if(EOF == c) return EOF;
	ungetc(c, f);

	for(p = s; l--; ){
		if(EOF == (c = getc(f))){
			*p = '\0';
			break;
		} else
		if(is_space(c)){
			*p = '\0';
			ungetc(c, f);
			break;
		} else *p++ = (char)c;
	}
	return p - s;
}

void	setargs(acp, avp, passcnt) /* newav[newac]NULLłۏ */
int	*acp, passcnt;
char	**avp[];
{
	register int	ac = *acp;
	register char	**av = *avp;

	newavsize = ac, newac = 0;
	newav = (char **)emalloc(NULL, (newavsize + 1) * sizeof(char *));
	ac--, add1arg(unixname(*av++));
	while(passcnt-- && ac--) add1arg(*av++);
	while(ac--) addarg(*av++);

	add1arg(NULL);
	do_qsortarg();
	if(newavsize > newac) newav = (char **)
			emalloc((char *)newav, (newac + 1) * sizeof(char *));
	*acp = newac, *avp = newav;
}

#ifdef UNIX
FILE	*pipewropen(cmd, av, otf, silentp)
register char	*cmd, **av;
FILE	*otf; /* otfflushcloseāAVFILEԂ */
int	silentp;
{
	int	pipefd[2];

	 /* output buffer͋ɂƂȂ */
	if(otf != NULL && (fflush(otf) == EOF || ferror(otf))) return NULL;

	if(-1 == pipe(pipefd)) (perror(NULL), exit(1));
	switch(wfork()){
	case 0: /* child */
		fclose(stdin);
		if(0 != dup(pipefd[0])) (perror(NULL), exit(1));
		if(otf == NULL){
			 /* stdoutcloseĂȂƉ */
			if(NULL == freopen("/dev/null", "w", stdout))
				(perror(NULL), exit(1));
		} else if(otf != stdout){
			fclose(stdout);
			if(1 != dup(fileno(otf))) (perror(NULL), exit(1));
			fclose(otf);
		}
		close(pipefd[0]), close(pipefd[1]);
		if(silentp && NULL == freopen("/dev/null", "w", stderr))
			(perror(NULL), exit(1));
		closenonstd();
		 /* qvZXłstdinEoutEerrgʂƉ */
		execvp(cmd, av);
		 /* through to perror */
	case -1:
		perror(NULL), exit(1);
	default:
		if(otf != NULL && otf != stdout) fclose(otf);
		close(pipefd[0]);
		return fdopen(pipefd[1], "w");
	}
}

FILE	*piperdopen(cmd, av, inf, silentp)
register char	*cmd, **av;
FILE	*inf;
int	silentp;
{
	int	pipefd[2];

	 /* output buffer͋ɂƂȂ */
	if(fflush(stdout) == EOF || ferror(stdout)) return NULL;

	if(inf == stdin) clearerr(stdin);
	if(-1 == pipe(pipefd)) (perror(NULL), exit(1));
	switch(wfork()){
	case 0: /* child */
		if(inf == NULL){
			 /* stdoutcloseĂȂƉ */
			if(NULL == freopen("/dev/null", "r", stdin))
				(perror(NULL), exit(1));
		} else if(inf != stdin){
			fclose(stdin);
			if(0 != dup(fileno(inf))) (perror(NULL), exit(1));
			fclose(inf);
		}
		fclose(stdout);
		if(1 != dup(pipefd[1])) (perror(NULL), exit(1));
		close(pipefd[0]), close(pipefd[1]);
		if(silentp && NULL == freopen("/dev/null", "w", stderr))
			(perror(NULL), exit(1));
		closenonstd();
		 /* qvZXłstdinEoutEerrgʂƉ */
		execvp(cmd, av);
		 /* through to perror */
	case -1:
		perror(NULL), exit(1);
	default:
		if(inf != NULL && inf != stdin) fclose(inf);
		close(pipefd[1]);
		return fdopen(pipefd[0], "r");
	}
}

static	FILE	*dirfindopen(s)
register char	*s;
{
	register FILE	*tmp;
	static	char	*av1[] = {
		"find", NULL, "(", "-type", "f", "-o", "-type", "d", ")",
		"-print", NULL
	};
	static	char	*av2[] = {
		"awk", "\
{if(prev!=\"\"&&substr($0,1,length(prev)+1)!=prev \"/\")print prev;prev=$0}\n\
END{print prev}", NULL
	};

	av1[1] = s;
	if(NULL == (tmp = execrdopen(*av1, av1, 1))) (perror(NULL), exit(1));
	return piperdopen(*av2, av2, tmp, 0);
	 /* wait()2ĂԂ */
}
#endif /* UNIX */

have8bit(s)
register char	*s;
{
	for(; *s; s++) if(!isascii(*s)) return 1;
	return 0;
}

isdirarg(s) /* s '/', '\' ŏI邩 */
register char	*s;
{
	for(; *s && s[1]; s++) if(iskanjipos(s)) s++;
	return isdelim(*s);
}

isDirarg(s) /* s '/', '\' 邢 ':' ŏI邩 */
register char	*s;
{
	for(; *s && s[1]; s++) if(iskanjipos(s)) s++;
	return isDelim(*s);
}

#ifndef UNIX
static	isdotdir(s)
register char	*s;
{
#define isdotonlydir(s) \
	(*(s) == '.' && (!*((s) + 1) || *((s) + 1) == '.' && !*((s) + 2)))

	if(isdotonlydir(s)) return 1;
	for(; *s; s++){
		if(iskanjipos(s)){
			s++;
			continue;
		}
		if(isDelim(*s) && isdotonlydir(s + 1)) return 1;
	}
	return 0;
}

iskanjipos(s)
char	*s;
{
	static	int	flag = -1;
	static	char	tmpbase[ ] = "a\201\\", fcbbuf[37];
	union	REGS	in, out;
	struct	SREGS	segreg;

	if(flag < 0){
		in . x . ax = 0x2900;
		in . x . si = FP_OFF(tmpbase);
		segreg . ds = FP_SEG((char far *)tmpbase);
		in . x . di = FP_OFF(fcbbuf);
		segreg . es = FP_SEG((char far *)fcbbuf);
		intdosx(&in, &out, &segreg);
		flag = (fcbbuf[3] == '\\');
	}
	if(!(flag &&
#ifdef iskanji
	   iskanji(*s)
#else
	   ((char)'\x81' <= *s && *s <= (char)'\x9f' ||
	    (char)'\xe0' <= *s && *s <= (char)'\xfc')
#endif
	  )) return 0;
	if(!s[1]){
		fprintf(stderr, "Incomplete KANJI filename\n");
		exit(1);
	}
	return 1;
}
#endif /* !UNIX */

char	*nameconv(s, mode) /* NULL͕ԂȂ */
register char	*s;
register int	mode;
 /* 0: MS-DOS -> UNIX, 1: UNIX -> MS-DOS. ւ̕ϊB̒
    sς̂͂BȑOԂɏ㏑̂Œ! ̊֐̒l͌Ƃ
    nameconv()ĂяoȂƂ킩Ă֐̈ɂ̂ݎg */
{
#define MODEMAX 2
	static	char	*p[MODEMAX] = {NULL, NULL};
	static	int	psize[MODEMAX] = {0, 0};

	if(strlen(s) >= psize[mode])
		p[mode] = emalloc(p[mode], (psize[mode] = strlen(s) + 1));
	for(s = strcpy(p[mode], s); *s; s++){
		if(iskanjipos(s)){
			s++;
			continue;
		}
#ifndef UNIX
		if(is_upper(*s)) *s = tolower(*s); else
#endif
		switch(mode){
		case 0:
			if(*s == '\\') *s = '/';
			break;
		case 1:
			if(*s == '/') *s = '\\';
			break;
		}
	}
	return p[mode];
}

char	*strsave(s)
 /* NULL͕ԂȂBnameconv()ԂsavêɂĝŁA̒ł
    nameconv()͎gȂ */
register char	*s;
{
	return strcpy(emalloc(NULL, strlen(s) + 1), s);
}

char	*strcatsave(s, r) /* NULL͕ԂȂ */
register char	*s, *r;
{
	register char	*p;
	register int	l;

	p = emalloc(NULL, (l = strlen(s)) + strlen(r) + 1);
	return(strcpy(p, s), strcpy(p + l, r), p);
}

char	*strpathcatsave(s, r) /* NULL͕ԂȂ */
register char	*s;
char	*r;
{
	register char	*p;
	int	l;
	char	notadd_delim; /* boolean */

	notadd_delim = (char)(!*s || isDirarg(s));
	p = emalloc(NULL, (l = strlen(s)) + !notadd_delim + strlen(r) + 1);
	strcpy(p, s), strcpy(p + l, DELIM + notadd_delim), strcat(p + l, r);
	return p;
}

#ifndef UNIX
static	char	*baseptr(s)
char	*s;
{
	register char	*p, *end = NULL;

	for(p = s; *p; p++){
		if(iskanjipos(p)) p++;
		 else if(isDelim(*p)) end = p;
	}
	return end == NULL ? s : ++end;
}

static	char	*strdircatsave(s, r) /* NULL͕ԂȂ */
char	*s, *r;
{
	register char	*p, *end;

	end = baseptr(s);
	p = emalloc(NULL, (end - s) + strlen(r) + 1);
	return(strcpy(p + (end - s), r), strncpy(p, s, end - s));
}
#endif /* !UNIX */

static	fnamecmp(x, y)
char	**x, **y;
{
#define codemap(a) (isdrvmk(a) ? -257 : isdelim(a) ? -256 : a)

	register unsigned char	*p, *q;
	int	a, b;

	for(p = (unsigned char *)*x, q = (unsigned char *)*y; ; p++, q++){
		if(iskanjipos(p) || iskanjipos(q)){
			if(*p != *q) return *p - *q;
			if(p[1] != q[1]) return p[1] - q[1];
			p++, q++;
			continue;
		}
		a = *p, b = *q;
		if(!a && !b) return 0;
		a = codemap(a), b = codemap(b);
		if(a != b) return a - b;
	}
}

static	void	must_qsortarg(beginac, endac)
register unsigned int	beginac, endac;
{
	if(endac - beginac < 2) return;
	mustsort = (struct sortrange *)emalloc(
		(char *)mustsort, sizeof(struct sortrange) * ++mustsort_num);
	mustsort[--mustsort_num] . begin = beginac;
	mustsort[mustsort_num++] . end = endac;
}

static	void	do_qsortarg()
{
	register int	i;

	for(i = mustsort_num; i--; ){
#ifdef DEBUG
		fprintf(stderr, "sorting args between %d and %d\n",
				mustsort[i] . begin, mustsort[i] . end - 1);
#endif
		qsort((char *)&newav[mustsort[i] . begin],
				mustsort[i] . end - mustsort[i] . begin,
						sizeof(char *), fnamecmp);
	}
	if(mustsort != NULL) free((char *)mustsort);
}

static	void	addarg(s)
register char	*s;
{
	register int	saveac = newac;

	if(*s == RESPF){
		addindarg(++s);
		if(saveac == newac){
			fprintf(stderr,
				"No files found in response file %s\n",
				strcmp(s, "-") ? s : STRSTDIN);
			 /* not exit */
		}
	} else {
		addf1arg(s);
	}
}

#ifdef UNIX
static	void	addf1arg(s) /* Œ1͈ǉ */
register char	*s;
{
	register FILE	*dirfind;
	register int	saveac = newac;

	if(isdir(s)){
		if(NULL == (dirfind = dirfindopen(s))) (perror(s), exit(1));
		addfoundarg(dirfind);
		fclose(dirfind);
		wait(NULL), wait(NULL); /* 2Kv */
		must_qsortarg(saveac, newac);
		 /* łqsortĂ͂ȂȂBStruncated buffer
		    ڂĂqsort邱 */
	} else {
		add1arg(s);
	}
}
#else /* !UNIX */
static	void	addf1arg(s) /* Œ1͈ǉ */
register char	*s;
{
	register int	saveac = newac;

	addfarg(s);
	if(saveac == newac){
		add1arg(s);
	} else {
		must_qsortarg(saveac, newac);
	}
}

#ifndef NOBRAEXP
static	void	nokanjibra()
{
	fprintf(stderr, "No KANJI allowed in '[ ]'.\n"), exit(1);
}

static	void	incompbra()
{
	fprintf(stderr, "Incomplete '[ ]'.\n"), exit(1);
}

static	void	matchbug(c, d)
char	c, d;
 /* c, dłȂꍇ邪̂Ƃ떳 */
{
	fprintf(stderr, "Bug? '%c' and '%c' unmatch\n", c, d), exit(1);
}

static	int	elimbracket(s)
register char	*s;
 /* '[ ]''?'ɏBs𒼐ڏB
    0AsȂ0ԂB
    {ꕶ'['Ƃ̏Փ˂͌Ă邪A'[ ]'̓{͔F߂Ȃ */
{
	register char	*p;
	register int	ret = 0, first;

	for(p = s; (*s = *p) != '\0'; p++, s++){
		if(iskanjipos(p)){*++s = *++p; continue;}
		if(*p != '[') continue;

		*s = '?', ret = 1; /* ̌pi߂ */
		if(*++p == BRAEXCEPT) p++;
		for(first = 1; ; first = 0, p++){
			if(!first && *p == ']') break;
			 /* ̏ꍇp͊Ofor[v1 */

			if(!*p) incompbra();
			if(iskanjipos(p)) nokanjibra();
			if(p[1] != '-') continue;

			p += 2;
			if(!*p) incompbra();
			if(iskanjipos(p)) nokanjibra();
		}
	}
	return ret;
}

static	int	matchbra(wild, name)
register char	*wild, *name;
 /* wildname}b`邩ׂB
    wild'[ ]''?'ɕς̂Ƀ}b`t@Cɑ΂ĂsB
    wildɂ͍\G[ȂƂA'[ ]'ɓ{͍ȂƂ */
{
	register char	namepos = 0;
	 /* namêǂ܂Ń}b`B0`8, 100`103 */
	register char	braok; /* 2rbĝݎgp */
	register char	namec, unamec;
	int	first;

#define BASE_END	8
#define EXT_BEGIN	100
#define EXT_END		103
#define at_EXTpos(i)	((i) == BASE_END || (i) == EXT_END)
#define at_EXTpos_k(i)	((i) == BASE_END - 1 || (i) == EXT_END - 1)
#define at_BASEpart(i)	((i) < EXT_BEGIN)
#define is_EXTend(c)	((c) == '.' || !(c))

	for( ; ; wild++){
		switch(*wild){
		case '\0':
			if(*name) matchbug(*wild, *name);
			return 1;
		case '.':
			if(!at_BASEpart(namepos) || !is_EXTend(*name)){
				matchbug(*wild, *name);
			}
			namepos = EXT_BEGIN;
			if(*name) name++;
			break;
		case '*':
			if(at_EXTpos(namepos)) continue;
			namepos = at_BASEpart(namepos) ? BASE_END : EXT_END;
			while(!is_EXTend(*name)) name++;
			break;
		case '?':
			if(at_EXTpos(namepos)) continue;
			namepos++;
			if(!is_EXTend(*name)) name++;
			break;
		case '[':
			braok = (*++wild == BRAEXCEPT) ? (wild++, 0) : 2;
			 /* ŏIIbraok03ȂOk */
			namec = to_lower(*name), unamec = to_upper(*name);
			for(first = 1; ; first = 0, wild++){
				if(!first && *wild == ']') break;
				 /* wild1i߂
				    ']'͕KĂ邱ƂO */
				if(wild[1] != '-'){
					if(braok & 1){ /* none */
					} else
					if(*wild == namec ||
					   *wild == unamec){
						braok |= 1;
					}
				} else {/* '[x-y]'̏ꍇ */
#define ucharLE(x, y) ((unsigned char)(x) <= (unsigned char)(y))
					if(braok & 1){ /* none */
					} else
					if(ucharLE(wild[0], wild[2])){
						if(ucharLE(wild[0], namec) &&
						   ucharLE(namec, wild[2]) ||
						   ucharLE(wild[0], unamec) &&
						   ucharLE(unamec, wild[2])){
							braok |= 1;
						}
					} else {
						if(wild[0] == namec ||
						   wild[0] == unamec ||
						   '-' == namec ||
						   wild[2] == namec ||
						   wild[2] == unamec){
							braok |= 1;
						}
					}
					wild += 2;
				}			
			}				
			if(at_EXTpos(namepos)) continue;
			if(is_EXTend(*name) || braok && braok != 3){
				/* matchbug(*wild, *name); */
				return 0;
			} /* abc[x-z]abc̓}b`Ȃ
			     abcyɂabc̓}b`Ȃ
			     abc?ɂabc̓}b` */
			namepos++;
			name++; /* !is_EXTend(*name)͐藧Ă */
			break;
		default:
			if(iskanjipos(name)) goto kanji;

			if(at_EXTpos(namepos)) continue;
			if(to_lower(*wild) != to_lower(*name)){
			 /* is_EXTend(*name)͂̏Ɋ܂܂ */
				matchbug(*wild, *name);
			}
			namepos++;
			name++; /* !is_EXTend(*name)͐藧Ă */
			break;
		kanji:
			if(at_EXTpos(namepos)) continue;
			if(at_EXTpos_k(namepos)){
			 /* ͂ȂƂ͎v */
				if(*wild != *name) matchbug(*wild, *name);
				namepos++;
				name++;
			} else {
				if(strncmp(wild, name, 2)){
					matchbug(*wild, *name);
				}
				namepos += 2;
				name += 2;
				wild++; /* Ƃł1i */
			}
			break;
		}
	}
}
#endif /* !NOBRAEXP */

static	void	addfarg(s)
register char	*s;
{
#ifndef NOBRAEXP
	register char	*origbase, *expandpath;
#endif
	register char	*tmppath;
	struct	find_t	mydta;

#ifdef DEBUG
	fprintf(stderr, "looking for '%s'...\n", s);
#endif
	if(isdotdir(s) || isDirarg(s)){
		adddirarg(s);
	} else {
#ifndef NOBRAEXP
		expandpath = strsave(dosname(s));
		origbase = strsave(tmppath = baseptr(expandpath));
		if(!elimbracket(tmppath)) (free(origbase), origbase = NULL);
		 /* expandpath̓e */
		if(0 == _dos_findfirst_e5(expandpath, 0x16, &mydta)){
#else
		if(0 == _dos_findfirst_e5(dosname(s), 0x16, &mydta)){
		 /* _dos_findfirstς߂dosname(s)̓e͕sv */
#endif
			do {
				if(*mydta . name == '.') continue;
				 /* '.', '..' ̏ꍇ */
#ifndef NOBRAEXP
				if(origbase != NULL &&
				   !matchbra(origbase, mydta . name))
					continue;
#endif
#ifdef DEBUG
				fprintf(stderr, "found '%s' in '%s'...\n",
							    mydta . name, s);
#endif
				tmppath = strdircatsave(s, mydta . name);
				if(mydta . attrib & 0x10){
					adddirarg(tmppath);
				} else {
					add1arg(unixname(tmppath));
				}
				free(tmppath);
			} while(0 == _dos_findnext_e5(&mydta));
		}
#ifndef NOBRAEXP
		if(origbase != NULL) free(origbase);
		free(expandpath);
#endif
	}
}
#endif /* UNIX */

#ifndef UNIX
static	void	adddirarg(s)
register char	*s;
{
	register char	*p;
	int	saveac = newac;

	addfarg(p = strpathcatsave(s, "*.*"));
	if(saveac == newac) add1arg(unixname(s));
	free(p);
}
#endif

static	void	addindfarg(resf)
register FILE	*resf;
{
	char	namebuf[MAXPATHLEN];

	for(;;){
		switch(fgetword(resf, namebuf, MAXPATHLEN)){
		case EOF:
			return;
		case MAXPATHLEN:
			fprintf(stderr, "Too long name: %.*s...\n",
							MAXPATHLEN, namebuf);
			exit(1);
		}
		addarg(namebuf);
	}
}

#ifdef UNIX
static	void	addfoundarg(resf) /* 1s1Ƃ */
register FILE	*resf;
{
	char	namebuf[MAXPATHLEN+1]; /* 1̍ő咷 MAXPATHLEN-1 */
	register int	l;

	for(;;){
		if(NULL == fgets(namebuf, MAXPATHLEN+1, resf)) return;
		if(0 != (l = strlen(namebuf))){
			if(namebuf[l - 1] == '\n'){
				namebuf[l - 1] = '\0';
			} else {
				if(l == MAXPATHLEN){
					fprintf(stderr,
					   "Too long name: %s...\n", namebuf);
					exit(1);
				}
			}
		}
		add1arg(namebuf);
	}
}
#endif

static	void	addindarg(s)
register char	*s;
{
	register FILE	*resf;

#ifdef SETARGS_DSHAR
	if(*s == RESPF){
		addindaarg(++s);
	} else
#endif
	if(!strcmp(s, "-")){
		clearerr(stdin);
		addindfarg(stdin);
	} else {
		addindfarg(resf = fopen_chk(s, "r"));
		fclose(resf);
	}
}

#ifdef SETARGS_DSHAR
static	void	addindaarg(s)
register char	*s;
{
	register FILE	*resf;

	if(!strcmp(s, "-")){
		clearerr(stdin);
		addindafarg(STRSTDIN, stdin);
	} else {
		addindafarg(s, resf = fopen_chk(s, "r"));
		fclose(resf);
	}
}

static	void	addindafarg(fname, resf)
char	*fname;
register FILE	*resf;
{
	char	namebuf[MAXPATHLEN];
	register char	*name;
	char	found = 0; /* boolean */
	char	instnum = '1';
#define MINSPACE  "    " /* 4 */
#define INSTSPACE "  "   /* 2 */

	if(NULL == fgets(name = namebuf, MAXPATHLEN, resf) ||
	   !strconsthead(name, "echo off") ||
	   NULL == fgets(name, MAXPATHLEN, resf) ||
	   !strconsthead(name, ": This is a") ||
	   NULL == fgets(name, MAXPATHLEN, resf) ||
	   *name != ':' || !strconsthead(name + 3, "1.")){
		goto notarc;
	}
	for(;;){
		if(EOF == fgetword(resf, name = namebuf, MAXPATHLEN) ||
		   *name != ':' || name[1] ||
		   NULL == fgets(name, sizeof(MINSPACE), resf)){
			goto notarc;
		}
		if(!strconsthead(name, MINSPACE)){
			if(++instnum <= '9' && name[2] == instnum &&
			   name[3] == '.' && strconsthead(name, INSTSPACE)){
				if(NULL == fgets(name, MAXPATHLEN, resf))
					goto notarc;
				continue;
			}
			if(found) return; else goto notarc;
		}

		switch(fgetword(resf, name, MAXPATHLEN)){
		case EOF:
			goto notarc;
		case MAXPATHLEN:
			fprintf(stderr, "Too long name: %.*s...\n",
							MAXPATHLEN, name);
			exit(1);
		}
		/* saveac = newac; *//* deleted */
		addf1arg(name); /* namefBNg̏ꍇ̒ */
		found = 1;

		if(NULL == fgets(name, MAXPATHLEN, resf)) goto notarc;
		while(*name == ' ' || *name == '\t') name++;
		if(*name != '\n' && !strconsthead(name, "\050empty dir"))
			goto notarc;
	}
notarc:
	fprintf(stderr, "%s: not seems to be a dshar archive\n", fname);
	exit(1);
}
#endif /* SETARGS_DSHAR */

static	void	add1buf_trunc(buf, len, beginac, endac)
char	*buf;
unsigned int	len, beginac, endac; /* nameconv()Ă΂Ȃ */
{
	register int	i;
	register char	*newbuf;

	if(!len){
		if(buf != NULL /* Ö */) free(buf);
		return;
	}

#ifndef DEBUG
	newbuf = emalloc(buf, len);
#else
	newbuf = emalloc(buf, len + 256);
	fprintf(stderr, "buf length truncated to %d, old %x, new %x\n",
							len, buf, newbuf);
#endif
	 /* Scurbuf̒ɂ͂ */
	for(i = beginac; i < endac; i++){
		newav[i] = newbuf + (newav[i] - buf);
#ifdef DEBUG
		fprintf(stderr,	"arg '%s' moved to truncated buf\n",
								newav[i]);
#endif
	}
}

static	void	add1arg(s) /* nameconv()Ă΂Ȃ */
register char	*s;
{
#define ARGBUFSIZ 1024
	static	char	*curbuf = NULL;
	static	unsigned int	curlen, beginac;
	register unsigned int	arglen;

	if(s == NULL){
		add1buf_trunc(curbuf, curlen, beginac, newac);
		newav[newac] = curbuf = NULL;
		return;
	}

	while(newac >= newavsize){
		newavsize += 63; newavsize &= ~31;
		newav = (char **)emalloc((char *)newav,
					(newavsize + 1) * sizeof(char *));
	}
#ifdef DEBUG
	fprintf(stderr, "allocated %d, saving into %d\n", newavsize, newac);
#endif

	arglen = strlen(s) + 1;
	if(NULL != curbuf && curlen + arglen > ARGBUFSIZ){
		add1buf_trunc(curbuf, curlen, beginac, newac);
		curbuf = NULL;
	}

	if(NULL == curbuf){
		if(arglen > ARGBUFSIZ ||
		   NULL == (curbuf = malloc(ARGBUFSIZ))){
			newav[newac++] = strsave(s);
#ifdef DEBUG
			fprintf(stderr, "arg '%s' saved to single buf\n", s);
#endif
			return;
		} else {
#ifdef DEBUG
			fprintf(stderr, "new argument buffer allocated\n");
#endif
			beginac = newac, curlen = 0;
		}
	}

#ifdef DEBUG
	fprintf(stderr, "arg '%s' saved to buf %x pos %d\n",
						s, (int)curbuf, curlen);
#endif
	 /* beginacnewac̊Ԃ̑Scurbufɂ͂ */
	strcpy(newav[newac++] = curbuf + curlen, s);
	curlen += arglen;
}

#ifdef DEBUGALONE
main(ac, av)
char	**av;
{
	int	i;

	setargs(&ac, &av, 0);
	for(i = 0; i < ac; i++) printf("arg %d = %s\n", i, av[i]);
	return 0;
}
#endif
